/* This file is part of the Views Template Library, written by
 * Gary Powell & Martin Weiser
 *
 * Copyright (c) 1999  Gary Powell
 * Copyright (c) 1999  Konrad Zuse Zentrum fuer Informationstechnik Berlin
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted 
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 */

#if !defined(_STL_FWDALGORITHM_HPP)
#define _STL_FWDALGORITHM_HPP	1

#if !defined(_VIEW_CONFIG_HPP)
#include "details/view_config.hpp"
#endif

#if !defined (USE_FORWARD_DECLARATIONS_OF_STD_ALGORITHM)

#if !defined(_SYS_LIBRARY_ALGORITHM_)
#include <algorithm>
#define _SYS_LIBRARY_ALGORITHM_
#endif // _SYS_LIBRARY_ALGORITHM_

#else
// forward declaration so we don't have to include <algorithm>
namespace std {
template <class _Tp>
	void swap(_Tp&, _Tp&);

template <class _InputIter1, class _InputIter2>
bool equal(_InputIter1, _InputIter1,
                  _InputIter2);

template <class _InputIter1, class _InputIter2>
bool lexicographical_compare(_InputIter1, _InputIter1,
                             _InputIter2, _InputIter2);

template <class T> 
const T& max(const T& , const T& );

template <class T> 
const T& min(const T& , const T& );

template <class IteratorType, class element_type>
IteratorType find(IteratorType, IteratorType, element_type const &);

template <class T1, class T2>
struct pair;

template <class InputIterator, class UnaryFunction>
UnaryFunction for_each(InputIterator , InputIterator , UnaryFunction );
};

#endif // USE_FORWARD_DECLARATIONS_OF_STD_ALGORITHM

#endif	 // _STL_FWDALGORITHM_HPP
// $Id: stl_algorithm_fwd.hpp,v 1.1 2000/11/20 14:11:11 bzfweise Exp $
